//
// Created by 安達 彰典 on 2013/06/24.
// Copyright (c) 2013 ___FULLUSERNAME___. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "StardustCrossHorizontalView.h"


@implementation StardustCrossHorizontalView

- (void)openMenus:(StardustMenuContent *)content {
    StardustMenuContent *child = content.head;
    CGRect frame = content.view.frame;
    NSUInteger order = 0;
    while (child.next) {
        child = child.next;
        frame.origin.y = 0;
        [child.view setFrame:frame];
        [self addSubview:child.view];
        [UIView animateWithDuration:0.3f animations:^{
            CGRect subViewFrame = frame;
            subViewFrame.origin.x = order * 120 + frame.origin.x;
            [child.view setFrame:subViewFrame];
        }                completion:^(BOOL finished) {
        }];
        order++;
    }
}

- (void)closeMenus:(StardustMenuContent *)content {
    CGRect frame = content.view.frame;
    NSUInteger order = 0;
    StardustMenuContent *child = content.head;
    while (child.next) {
        child = child.next;
        [UIView animateWithDuration:0.3f animations:^{
            CGRect subViewFrame = frame;
            subViewFrame.origin.x = 0;
            subViewFrame.origin.y = 0;
            [child.view setFrame:subViewFrame];
        }                completion:^(BOOL finished) {
            [child.view removeFromSuperview];
        }];
        order++;
    }
}

@end