//
// Created by 安達 彰典 on 2013/06/17.
// Copyright (c) 2013 ___FULLUSERNAME___. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import <UIKit/UIKit.h>
#import "StardustMenuContent.h"
#import "StardustHash.h"

@interface StardustMenuContent ()
@property dispatch_semaphore_t sem;
@end

@implementation StardustMenuContent

+ (StardustMenuContent *)stardustCrossContentWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click{
    StardustMenuContent *content = [[StardustMenuContent alloc] init];
    content.view = [[UIView alloc] init];
    content.view.backgroundColor = [UIColor blueColor];
    content.caption = text;
    content.onClick = click;
    content.label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, 20, 30)];
    [content.view addSubview:content.label];
    content.tag = [StardustHash hash];
    content.fallen = NO;
    content.head = [[StardustMenuContent alloc] init];
    return content;
}

- (id)init{
    if(self = [super init]){
       _sem = dispatch_semaphore_create(1);
    }
    return self;
}

- (StardustMenuContent *)tail {
    dispatch_semaphore_wait(self.sem, DISPATCH_TIME_FOREVER);
    StardustMenuContent *cur = self.head;
    while (cur.next) {
        cur = cur.next;
    }
    dispatch_semaphore_signal(self.sem);
    return cur;
}

@end