//
// Created by 安達 彰典 on 2013/06/16.
// Copyright (c) 2013 ___FULLUSERNAME___. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import <Foundation/Foundation.h>
#import "StardustCrossView.h"
#import "StardustMenuContent.h"


@interface StardustCrossManager : NSObject

@property (retain) StardustMenuContent *head;
@property (retain) StardustCrossView *view;
@property NSInteger count;

typedef NS_ENUM(NSUInteger, SDMoveType) {
    SDMoveToUpper=1,
    SDMoveToDowner,
    SDMoveNeutral,
};

- (StardustMenuContent *)tail;
- (id)init ;

- (BOOL)fallingStars;
- (void)dragMovingView:(CGFloat)touchMoveY origin:(CGFloat)touchBeganY;
- (void)dragMovingEnd:(CGPoint)touchPoint;

- (StardustMenuContent *)addMenuWithImage:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click;
- (void)removeMenuWithTag:(NSString *)tag;

- (NSString *)addMenuChildWithTag:(NSString *)tag image:(UIImage *)image text:(NSString *)text onClick:(dispatch_block_t)click;
- (void)removeMenuChildWithTag:(NSString *)tag;
@end