//
//  ViewController.m
//  StardustCrossViewSample
//
//  Created by 安達 彰典 on 06/17/13.
//  Copyright (c) 2013 com.regaria. All rights reserved.
//

#import "ViewController.h"
#import <StardustCrossView/StardustCrossView.h>

@interface ViewController ()
@property StardustCrossView *stardustView;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)viewWillAppear:(BOOL)animated {

    StardustCrossView *view = [[StardustCrossView alloc] initWithFrame:CGRectMake(50, 0, 100, 480)];
    self.stardustView = view;
//    view.backgroundColor = [UIColor redColor];
    [self.view addSubview:view];

    dispatch_block_t block = ^{
        NSLog(@"Now clicked.");
    };

    NSString *tagMenu0 =[view addMenuWithImage:nil text:@"text1" onClick:block];
    [view addMenuChildWithImage:nil text:@"sub1" onClick:block tag:tagMenu0];
    [view addMenuChildWithImage:nil text:@"sub1" onClick:block tag:tagMenu0];
    [view addMenuChildWithImage:nil text:@"sub1" onClick:block tag:tagMenu0];

    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view addMenuWithImage:nil text:@"text1" onClick:nil];

    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view addMenuWithImage:nil text:@"text1" onClick:nil];
    [view fallingStars];

    UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    [button setFrame:CGRectMake(200, 0, 100, 50)];
    [button setTitle:@"addMenu" forState:UIControlStateNormal];
    [button addTarget:self action:@selector(pushAddMenuButton:) forControlEvents:UIControlEventTouchDown];
    [self.view addSubview:button];

    UIButton *button2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    [button2 setFrame:CGRectMake(200, 50, 100, 50)];
    [button2 setTitle:@"falling" forState:UIControlStateNormal];
    [button2 addTarget:self action:@selector(pushFallingStar:) forControlEvents:UIControlEventTouchDown];
    [self.view addSubview:button2];
}

- (void)pushAddMenuButton:(id)sender{
    [self.stardustView addMenuWithImage:nil text:@"text1" onClick:nil];
}
- (void)pushFallingStar:(id)sender{
    [self.stardustView fallingStars];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end